
// Upcasting and late binding
//
class Note {
  private String noteName;
  private Note(String noteName) {
    this.noteName = noteName;
  }
  public String toString() { return noteName; }
  public static final Note
    MIDDLE_C = new Note("Middle C"),
    C_SHARP  = new Note("C Sharp"),
    B_FLAT   = new Note("B Flat");
    // Etc.
} ///:~
class Instrument {
  public void play( Note n ) {}
  static void tune( Instrument i ) {
    // ...
    i.play( Note.C_SHARP );
  }
}
class Wind extends Instrument {
	  public void play(Note n) {
	    System.out.println("Wind.play() " + n);
	  }
}
class Stringed extends Instrument {
  public void play(Note n) {
    System.out.println("Stringed.play() " + n);
  }
}

class Brass extends Wind {
  public void play(Note n) {
    System.out.println("Brass.play() " + n);
  }
}

public class Music {
  public static void main(String[] args) {
    Wind flute = new Wind();
    Stringed violin = new Stringed();
    Brass frenchHorn = new Brass();
    
  }
} ///:~